#include "../../../../bin_x86/TSMaster.h"
#pragma comment(lib, "../../../../bin_x86/TSMaster.lib")
#include <windows.h>
#include <thread>
#include <string>
#include <iostream>
using namespace std;

//#define TS_MSG_DONTWAIT 0x08

static bool thread_running;
void thread_udp_server(int network, int sock) {
	u8 buf[2000];
	int count;
	while (thread_running)
	{
		Tts_sockaddr_in from_addr;
		u32 len = sizeof(Tts_sockaddr_in);
		//4 == TS_MSG_DONTWAIT 
		//4 == 0 
		count = tssocket_recvfrom(sock, (ps32)buf, 2000, TS_MSG_DONTWAIT, (Pts_sockaddr)&from_addr, &len);
		if (count > 0) {
			printf("tssocket_recv: %d  from ipaddr: %s, port: %d\n", count, tssocket_ntoa((Tip4_addr_t*)&from_addr.sin_addr), tssocket_htons(from_addr.sin_port));
		}
		Sleep(10);
	}
}

std::wstring GetRegValue(HKEY hKeyType, DWORD dwType, LPCTSTR lpPath, LPCTSTR lpName)
{
	HKEY hKEY;
	DWORD dataSize = MAX_PATH;
	char data[MAX_PATH];
	std::string strValue("");
	if (RegOpenKeyEx(hKeyType, lpPath, NULL, KEY_READ, &hKEY) == ERROR_SUCCESS)        //޷hKEY,ִֹ  
	{
		long lRet = RegQueryValueEx(hKEY, lpName, NULL, &dwType, (LPBYTE)data, &dataSize);
		if (lRet == ERROR_SUCCESS)
		{
			for (int i = 0; i < (int)dataSize; i++)
			{
				strValue = strValue + data[i];
			}
		}
		RegCloseKey(hKEY);        // ǰҪرѾ򿪵 hKEY
	}
	else
	{
		RegCreateKeyEx(hKeyType, (LPCTSTR)lpPath, 0, NULL, NULL, KEY_WRITE, NULL, &hKEY, NULL);
		RegCloseKey(hKEY);        // ǰҪرѾ򿪵 hKEY
	}
	std::wstring wstrValue((wchar_t*)strValue.data(), strValue.length() / 2);
	return wstrValue;
}

int main()
{
	s32 status;
	//ӳټؼ ԼȱTSMaster.dllλ
	SetDefaultDllDirectories(7680);
	std::wstring strValue;
	strValue = GetRegValue(HKEY_CURRENT_USER, REG_SZ, L"Software\\TOSUN\\TSMaster", L"bin");
	AddDllDirectory(strValue.c_str());
	AddDllDirectory(L"./");

	initialize_lib_tsmaster("ETHUDPDemo");
	tsapp_show_tsmaster_window("Hardware", true);
	status = tssocket_initialize(0);
	Tip4_addr_t ipaddr, gw, netmask;
	//ipaddress 
	tssocket_aton("192.168.0.50", &ipaddr);
	//gateway
	tssocket_aton("192.168.0.1", &gw);
	//mask
	tssocket_aton("255.255.255.0", &netmask);

	//mac addresss
	u8 macaddr[6] = { 1,2,3,4,5,50 };

	status = tssocket_add_device(0, macaddr, ipaddr, netmask, gw, 1500);

	status = tsapp_connect();

	
	if (status != 0) return -1;
	int sock = tssocket(0, TS_AF_INET, TS_SOCK_DGRAM, 0, NULL,NULL,NULL);

	if (sock == -1) return -1;
	int err = -1;
	Tts_sockaddr_in self1_addr;
	self1_addr.sin_family = TS_AF_INET;
	self1_addr.sin_port = tssocket_htons(51051);
	tssocket_aton("192.168.0.50", (Tip4_addr_t*)&self1_addr.sin_addr);

	err = tssocket_bind(sock, (Tts_sockaddr*)&self1_addr, sizeof(Tts_sockaddr));
	thread_running = true;
	std::thread t1(thread_udp_server, CH1, sock);

	Tts_sockaddr_in dstaddr;
	dstaddr.sin_family = TS_AF_INET;
	dstaddr.sin_port = tssocket_htons(51051);
	tssocket_aton("192.168.0.51", (Tip4_addr_t*)&dstaddr.sin_addr);
	u8 buf[1400] = { 0 };
	for (s32 i = 0; i < 1400; i++)
		buf[i] = (u8)i;
	while (1)
	{
		int data;
		cin >> data;
		cout << data << endl;
		if (data == 1)
		{
			err = tssocket_sendto(sock, (ps32)buf, 1400, 0, (Tts_sockaddr*)&dstaddr, sizeof(Tts_sockaddr));
		}
		else if (data == 2)
		{
			break;
		}
	}
	thread_running = false;
	t1.join();
	tssocket_close(sock);
	status = tsapp_disconnect();
	tssocket_remove_device(CH1, macaddr, &ipaddr);
	tssocket_finalize(CH1);
	finalize_lib_tsmaster();
	return 0;


}